//SPDX-License-Identifier: UNLICENSED

pragma solidity >=0.6;

contract certification{
    mapping(address=>uint) private application_time;
    mapping(address=>string) private certification_name;
    mapping(address=>uint) private certification_time;
    mapping(address=>uint) private certification_level;
    address payable public authority;
    uint public fee;

    constructor(uint f){
        authority=payable(msg.sender);
        fee=f;
    }

    function enrol() public payable{
        require(msg.value>=fee,"You have to pay the fee");
        application_time[msg.sender]=block.timestamp;
    }

    function insert(address a,string memory name,uint level) public returns(bool){
        require(msg.sender==authority,"You are not the authority");
        require(application_time[a]>=block.timestamp+90*24*60*60,"You have no valid application in the last 90 days");
        if(certification_level[a]>level){
            return false;
        }else{
            certification_name[a]=name;
            certification_time[a]=block.timestamp;
            certification_level[a]=level;
            application_time[a]=0; // remember to reset the application
            return true;
        }
    }

    function check(address a, string memory name, uint level) public view returns(uint){
        if(certification_name[a] == name && certification_level[a]>=level){
//        if(keccak256(abi.encodePacked(certification_name[a])) == keccak256(abi.encodePacked(name)) && certification_level[a]>=level){
            return certification_time[a];
        }else{
            return 0;
        }
    }

    function cancel() public payable{
        require(msg.value>=fee,"You did not pay the fee");
        certification_name[msg.sender]="";
        certification_time[msg.sender]=0;
        certification_level[msg.sender]=0;
    }

}